# NOTE: tests >100 processes, so ensure proper ulimit
#
# Conditional build:
%bcond_without	doc		# build without documentation
%bcond_with	clisp		# build using clisp instead of sbcl
%bcond_without	cl_controller	# common-lisp-controller support
#
# To build with an unpackaged Common Lisp implementation,
# pass --define bootstrap_cl /path/to/lisp/binary to builder.
#
Summary:	The Steel Bank Common Lisp development environment
Summary(pl.UTF-8):	Środowisko programowania Steel Bank Common Lisp
Name:		sbcl
Version:	1.3.10
Release:	1
License:	MIT
Group:		Development/Languages
Source0:	http://download.sourceforge.net/sbcl/%{name}-%{version}-source.tar.bz2
# Source0-md5:	c8bd43e149109127651a6917976dda4a
Source1:	sbcl.sh
Source2:	sbcl.rc
Source3:	sbcl-install-clc.lisp
Source10:	http://download.sourceforge.net/sbcl/sbcl-1.2.7-x86-linux-binary.tar.bz2
# Source10-md5:	f6a1b2137fbc74b4a8aaf338643f4ae2
Source11:	http://download.sourceforge.net/sbcl/sbcl-1.3.10-x86-64-linux-binary.tar.bz2
# Source11-md5:	56fe67f916ccdd84e7b739d0a731cf9f
# TODO (portability) - also available:
#SourceXX:	http://download.sourceforge.net/sbcl/sbcl-1.3.10-arm64-linux-binary.tar.bz2
#SourceXX:	http://download.sourceforge.net/sbcl/sbcl-1.3.9-armhf-linux-binary.tar.bz2
#SourceXX:	http://download.sourceforge.net/sbcl/sbcl-1.2.7-armel-linux-binary.tar.bz2
#SourceXX:	http://download.sourceforge.net/sbcl/sbcl-1.2.7-powerpc-linux-binary.tar.bz2
#SourceXX:	http://download.sourceforge.net/sbcl/sbcl-1.0.23-mips-linux-binary.tar.bz2
#SourceXX:	http://download.sourceforge.net/sbcl/sbcl-1.0.28-mipsel-linux-binary.tar.bz2
#SourceXX:	http://download.sourceforge.net/sbcl/sbcl-1.0.28-alpha-linux-binary.tar.bz2
#SourceXX:	http://download.sourceforge.net/sbcl/sbcl-1.0.28-sparc-linux-binary.tar.bz2
Patch0:		%{name}-tests.patch
Patch1:		%{name}-threads.patch
Patch2:		%{name}-info.patch
URL:		http://sbcl.sourceforge.net/
%{?with_clisp:BuildRequires:	clisp}
%if %{with doc}
BuildRequires:	tetex-dvips
BuildRequires:	texinfo-texi2dvi
%endif
%if %{with cl_controller}
Requires(post,preun):	common-lisp-controller
Requires:	common-lisp-controller
%endif
%if %{without clisp}
%{!?bootstrap_cl:ExclusiveArch:	%{ix86} %{x8664}}
# also: %{arm} aarch64 alpha mips mipsel ppc sparc
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Steel Bank Common Lisp (SBCL) is a Open Source development environment
for Common Lisp based on CMUCL. It includes an integrated native
compiler, interpreter, and debugger.

%description -l pl.UTF-8
Steel Bank Common Lisp (SBCL) to środowisko programistyczne Open
Source dla Common Lispa oparte na CMUCL. Zawiera zintegrowany natywny
kompilator, interpreter i debugger.

%package doc-info
Summary:	The Steel Bank Common Lisp documentation (info)
Summary(pl.UTF-8):	Dokumentacja Steel Bank Common Lisp (info)
Group:		Development/Languages

%description doc-info
Documentation of Steel Bank Common Lisp (SBCL) in info format.

%description doc-info -l pl.UTF-8
Dokumentacja Steel Bank Common Lisp (SBCL) w formacie info.

%package doc-html
Summary:	The Steel Bank Common Lisp documentation (HTML)
Summary(pl.UTF-8):	Dokumentacja Steel Bank Common Lisp (HTML)
Group:		Development/Languages

%description doc-html
Documentation of Steel Bank Common Lisp (SBCL) in HTML format.

%description doc-html -l pl.UTF-8
Dokumentacja Steel Bank Common Lisp (SBCL) w formacie HTML.

%package doc-pdf
Summary:	The Steel Bank Common Lisp documentation (PDF)
Summary(pl.UTF-8):	Dokumentacja Steel Bank Common Lisp (PDF)
Group:		Development/Languages

%description doc-pdf
Documentation of Steel Bank Common Lisp (SBCL) in PDF format.

%description doc-pdf -l pl.UTF-8
Dokumentacja Steel Bank Common Lisp (SBCL) w formacie PDF.

%prep
%ifarch %{ix86}
%setup -q -a 10
%endif
%ifarch %{x8664}
%setup -q -a 11
%endif
%patch0 -p1
%ifarch %{ix86} %{x8664}
%patch1 -p1
%endif
%patch2 -p1

mkdir sbcl-bootstrap
cd sbcl-*-linux
INSTALL_ROOT=`pwd`/../sbcl-bootstrap sh ./install.sh
cd -

# clean.sh is so stupid it removed sbcl-bootstrap contents
%{__mv} clean.sh clean.sh.orig
echo "#!/bin/sh" >clean.sh
chmod 755 clean.sh

%if %{with clisp}
%define bootstrap_cl "clisp"
%endif

%build
export GNUMAKE="make"
export CC="%{__cc}"
export CFLAGS="%{rpmcflags}"
export SBCL_HOME=`pwd`/sbcl-bootstrap/lib/sbcl
export PATH=`pwd`/sbcl-bootstrap/bin:${PATH}
./make.sh \
	--prefix=%{_prefix} \
	%{?bootstrap_cl}

%if %{with doc}
%{__make} -C doc/manual -j1
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_libdir},%{_mandir},%{_infodir}} \
	$RPM_BUILD_ROOT/etc/env.d

env -u SBCL_HOME INSTALL_ROOT=`pwd`/_install %{_buildshell} ./install.sh

%{__mv} _install/lib/sbcl $RPM_BUILD_ROOT%{_libdir}/%{name}
%{__mv} _install/bin/sbcl $RPM_BUILD_ROOT%{_bindir}/%{name}
%{__mv} _install/share/man/* $RPM_BUILD_ROOT%{_mandir}
%if %{with doc}
%{__mv} _install/share/info/*.info* $RPM_BUILD_ROOT%{_infodir}
%endif

echo SBCL_HOME=%{_libdir}/%{name} > $RPM_BUILD_ROOT/etc/env.d/SBCL_HOME

%if %{with cl_controller}
install -d $RPM_BUILD_ROOT{/usr/lib/common-lisp/bin,%{_sysconfdir}}
%{__sed} -e 's,/usr/lib/sbcl,%{_libdir}/%{name},g' %{SOURCE1} >$RPM_BUILD_ROOT/usr/lib/common-lisp/bin/sbcl.sh
install -Dp %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/sbcl.rc
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{_libdir}/%{name}/install-clc.lisp
%{__mv} $RPM_BUILD_ROOT%{_libdir}/%{name}/sbcl.core $RPM_BUILD_ROOT%{_libdir}/%{name}/sbcl-dist.core
touch $RPM_BUILD_ROOT%{_libdir}/%{name}/sbcl.core
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%env_update
%if %{with cl_controller}
test -f %{_libdir}/%{name}/sbcl.core || cp -p %{_libdir}/%{name}/sbcl-dist.core %{_libdir}/%{name}/sbcl.core
/usr/sbin/register-common-lisp-implementation sbcl >/dev/null 2>&1 ||:
%endif

%postun
%env_update

%if %{with cl_controller}
if [ $1 -eq 0 ]; then
	/usr/sbin/unregister-common-lisp-implementation sbcl >/dev/null 2>&1 ||:
fi
%endif

%if %{with doc}
%post doc-info	-p /sbin/postshell
-/usr/sbin/fix-info-dir -c %{_infodir}

%postun doc-info
[ ! -x /usr/sbin/fix-info-dir ] || /usr/sbin/fix-info-dir -c %{_infodir} >/dev/null 2>&1
%endif

%files
%defattr(644,root,root,755)
%doc _install/share/doc/sbcl/{BUGS,COPYING,CREDITS,NEWS}
%attr (755,root,root) %{_bindir}/sbcl
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/contrib
%{_mandir}/man1/sbcl.1*
%config(noreplace,missingok) %verify(not md5 mtime size) /etc/env.d/SBCL_HOME
%if %{with cl_controller}
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/sbcl.rc
%attr(744,root,root) /usr/lib/common-lisp/bin/sbcl.sh
%{_libdir}/%{name}/install-clc.lisp
%{_libdir}/%{name}/sbcl-dist.core
%ghost %{_libdir}/%{name}/sbcl.core
%else
%{_libdir}/%{name}/sbcl.core
%endif

%if %{with doc}
%files doc-info
%defattr(644,root,root,755)
%{_infodir}/asdf.info*
%{_infodir}/sbcl.info*

%files doc-html
%defattr(644,root,root,755)
%doc _install/share/doc/sbcl/*.html

%files doc-pdf
%defattr(644,root,root,755)
%doc _install/share/doc/sbcl/*.pdf
%endif
%changelog
* Tue Oct 11 2016 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/sbcl.git;a=log;h=master

* Tue Oct 11 2016 Jakub Bogusz <qboosh@pld-linux.org> 840a705
- controller is not required to build

* Mon Oct 10 2016 Jakub Bogusz <qboosh@pld-linux.org> 54f94c0
- updated common-lisp-controller scripts for current sbcl

* Mon Oct 10 2016 Jakub Bogusz <qboosh@pld-linux.org> db31b6d
- controller bugfixes

* Mon Oct 10 2016 Jakub Bogusz <qboosh@pld-linux.org> 294d301
- added common-lisp-controller support from Fedora

* Sun Oct 09 2016 Jakub Bogusz <qboosh@pld-linux.org> 2f19d43
- debug cleanup

* Sun Oct 09 2016 Jakub Bogusz <qboosh@pld-linux.org> 535364a
- updated to 1.3.10 and latests bootstraps (x86 1.2.7, x86-64 1.3.10)
- added info patch (unify @direntry)

* Fri Apr 26 2013 Jan Rękorajski <baggins@pld-linux.org> d117b6a
- rel 1

* Fri Apr 26 2013 Jan Rękorajski <baggins@pld-linux.org> 9edfda1
- disable test that tries to mess with /dev/log

* Fri Apr 26 2013 Jan Rękorajski <baggins@pld-linux.org> c7dd8c2
- updated to 1.1.6
- reworked bootstrap to use internal binaries (clisp no longer works)

* Sun May 25 2008 japhy <japhy@pld-linux.org> 99edc23
- Up to 1.0.16

* Thu Jan 24 2008 Elan Ruusamäe <glen@pld-linux.org> 17eb1cb
- invoke fix-info-dir via /sbin/postshell where possible to avoid extra /bin/sh dep

* Wed Dec 05 2007 japhy <japhy@pld-linux.org> 9137cf2
- Up to 1.0.12

* Mon Feb 12 2007 Elan Ruusamäe <glen@pld-linux.org> 1806086
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> e072dea
- converted to UTF-8

* Tue Jan 30 2007 japhy <japhy@pld-linux.org> e22d414
- Up to 1.0.2
- Make it possible to use unpackaged host CL implementation by passing
  --define bootstrap_cl /path/to/lisp/binary to builder
- Rewrite installation, install to %{_libdir} instead of
  %{_prefix}/lib, make it work on x86_64
- Add /etc/env.d/SBCL_HOME

* Sun Aug 27 2006 qrczak <qrczak@pld-linux.org> 75f33d9
- Threads are enabled on supported architectures (x86 and x86_64).

* Mon Mar 13 2006 qrczak <qrczak@pld-linux.org> e6c3455
- Threads are enabled on supported architectures (x86 and x86_64).
- Release 2.

* Tue Feb 28 2006 Jakub Bogusz <qboosh@pld-linux.org> 1b71e2d
- cleanup

* Tue Feb 28 2006 japhy <japhy@pld-linux.org> 8e4ff5c
- Up to 0.9.10
- New bcond without_doc to build without documentation
- New bcond with_clisp to bootstrap using clisp when no sbcl is available

* Thu Dec 29 2005 qrczak <qrczak@pld-linux.org> 5f35e5b
- Updated to sbcl-0.9.8.
- sbcl-gcc4.patch no longer needed.

